WebApplication1/Models/Topic.cs
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Threading.Tasks;

namespace WebApplication1.Models
{
    public class Topic: Entity
    {
        [Required]
        public string TopicName { get; set; }
        public string AuthorName { get; set; }
        [Required]
        public string TopicText { get; set; }
        public DateTime CreationDate { get; set; }
        public User User { get; set; }
        public string UserId { get; set; }

        public int MessageCount { get; set; }

        public List<Comment> Comments { get; set; }
    }
}

WebApplication1/Controllers/CommentController.cs
using System;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using WebApplication1.Models;
using WebApplication1.Repositories;
using WebApplication1.ViewModels;

namespace WebApplication1.Controllers
{
    public class CommentController : Controller
    {
        private IUnitOfWorkFactory _unitOfWorkFactory;
        private readonly UserManager<User> _userManager;

        public CommentController(IUnitOfWorkFactory unitOfWorkFactory, UserManager<User> userManager)
        {
            _unitOfWorkFactory = unitOfWorkFactory;
            _userManager = userManager;
        }

        public async Task<IActionResult> CreateComment(string text, int topicId, string userId, int pageNumber = 1)
        {
            using (var unitOfWork = _unitOfWorkFactory.MakeUnitOfWork())
            {
                Comment comment = new Comment()
                {
                    Text = text,
                    TopicId = topicId,
                    UserId = userId,
                    AuthorName = User.Identity.Name,
                    CommentDate = DateTime.Now
                };
                var topic = await unitOfWork.Topics.GetByIdAsync(topicId);
                topic.MessageCount++;
                unitOfWork.Topics.UpdateAsync(topic);
                await unitOfWork.Comments.CreateAsync(comment);
                await unitOfWork.CompleteAsync();
                var comments = unitOfWork.Comments.GetAllAsync().Result.Where(c => c.TopicId == topicId).ToList();
                int pageSize = 5;
                var items = comments.Skip((pageNumber - 1) * pageSize).Take(pageSize).ToList();
                var count = comments.Count;
                PageViewModel pageViewModel = new PageViewModel(count, pageNumber, pageSize);
                var users = _userManager.Users;
                foreach (var item in items)
                {
                    item.User = users.FirstOrDefault(c => c.Id == item.UserId);
                }
                IndexViewModel indexViewModel = new IndexViewModel
                {
                    PageViewModel = pageViewModel,
                    Comments = items
                };
                CommentViewModel commentView = new CommentViewModel
                {

                    Comment = new Comment(),
                    Topic = topic,
                    IndexViewModel = indexViewModel
                };
                return PartialView("CommentsAjax", commentView);
            }
        }
    }
}

WebApplication1/Controllers/TopicController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using WebApplication1.Models;
using WebApplication1.Repositories;
using WebApplication1.ViewModels;

namespace WebApplication1.Controllers
{
    public class TopicController : Controller
    {
        private IUnitOfWorkFactory _unitOfWorkFactory;
        private readonly UserManager<User> _userManager;

        public TopicController(IUnitOfWorkFactory unitOfWorkFactory, UserManager<User> userManager)
        {
            _unitOfWorkFactory = unitOfWorkFactory;
            _userManager = userManager;
        }

        public async Task<ActionResult> Create()
        {
            var user = await _userManager.FindByNameAsync(User.Identity.Name);
            if(user !=null)
            ViewBag.UserId = user.Id;
            ViewBag.Date = DateTime.Now;
            return View("~/Views/Topic/Create.cshtml");
        }

        [HttpPost]
        public async Task<ActionResult> CreateTopic(Topic topic)
        {
            using (var unitOfWork = _unitOfWorkFactory.MakeUnitOfWork())
            {
               topic.AuthorName = User.Identity.Name;
               await unitOfWork.Topics.CreateAsync(topic);
               await unitOfWork.CompleteAsync();
               return RedirectToAction("Index", "Home");
            }
            
        }

        public async Task<IActionResult> IndexAsync(int id, int pageNumber = 1)
        {
            using (var unitOfWork = _unitOfWorkFactory.MakeUnitOfWork())
            {
                int pageSize = 5;

                var topic = await unitOfWork.Topics.GetByIdAsync(id);
                var comments = unitOfWork.Comments.GetAllAsync().Result.Where(c => c.TopicId == topic.Id).ToList();
                var count = comments.Count;
                var items = comments.Skip((pageNumber - 1) * pageSize).Take(pageSize).ToList();
                var users = _userManager.Users;
                foreach (var item in items)
                {
                    item.User = users.FirstOrDefault(c => c.Id == item.UserId);
                }
                PageViewModel pageViewModel = new PageViewModel(count, pageNumber, pageSize);
                IndexViewModel indexViewModel = new IndexViewModel
                {
                    PageViewModel = pageViewModel,
                    Comments = items
                };
                CommentViewModel comment = new CommentViewModel() {Comment = new Comment(), Topic = topic, IndexViewModel = indexViewModel};
                return View("Index", comment);
            }
        }

        public async Task<IActionResult> PaginationAjaxResultAsync(int id, int pageNumber)
        {
            using (var unitOfWork = _unitOfWorkFactory.MakeUnitOfWork())
            {
                int pageSize = 5;

                var topic = await unitOfWork.Topics.GetByIdAsync(id);
                var comments = unitOfWork.Comments.GetAllAsync().Result.Where(c => c.TopicId == topic.Id).ToList();
                var items = comments.Skip((pageNumber - 1) * pageSize).Take(pageSize).ToList();
                var count = comments.Count;
                var users = _userManager.Users;
                foreach (var item in items)
                {
                    item.User = users.FirstOrDefault(c => c.Id == item.UserId);
                }
                PageViewModel pageViewModel = new PageViewModel(count, pageNumber, pageSize);
                IndexViewModel indexViewModel = new IndexViewModel
                {
                    PageViewModel = pageViewModel,
                    Comments = items
                };
                CommentViewModel comment = new CommentViewModel {

                    Comment = new Comment(),
                    Topic = topic,
                    IndexViewModel = indexViewModel
                };
                return PartialView("PaginationResult", comment);
            }
        }
    }
}

WebApplication1/Views/Topic/Create.cshtml
@model WebApplication1.Models.Topic

@{
    ViewData["Title"] = "Create";
}

<h1>Create</h1>

<h4>Topic</h4>
<hr />
<div class="row">
    <div class="col-md-4">
        <form asp-action="CreateTopic">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <div class="form-group">
                <label asp-for="TopicName" class="control-label">Название темы</label>
                <input asp-for="TopicName" class="form-control" />
                <span asp-validation-for="TopicName" class="text-danger"></span>
            </div>
            <div class="form-group">
                <textarea asp-for="TopicText" class="form-control"></textarea>
                <span asp-validation-for="TopicText" class="text-danger"></span>
            </div>
                <input type="hidden" value="@ViewBag.Date" asp-for="CreationDate" />
                <input type="hidden" asp-for="UserId" value="@ViewBag.UserId">
            <div class="form-group">
                <input type="submit" value="Create" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-action="Index">Back to List</a>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
}

WebApplication1/Views/Topic/Index.cshtml
@model WebApplication1.ViewModels.CommentViewModel

@{
    ViewData["Title"] = "Index";
}
<h1>@Model.Topic.TopicName</h1>
    <div>
        <hr />
        <dl class="row">
            <dt class="col-sm-2">
                Автор
            </dt>
            <dd class="col-sm-10">
                @Html.DisplayFor(model => model.Topic.AuthorName)
            </dd>

            <dt class="col-sm-2">
                Текст темы
            </dt>
            <dd class="col-sm-10">
                @Html.DisplayFor(model => model.Topic.TopicText)
            </dd>
        </dl>
    </div>
    <hr />
    @if (Model.IndexViewModel.Comments != null)
{
    <h2>Комментарии</h2>
    <hr />
    <div>
        <div id="comments">
            <table>
                <tr>
                    <th></th>
                    <th>Автор</th>
                    <th>Сообщение</th>
                    <th>Дата ответа</th>
                </tr>

                @foreach (var item in Model.IndexViewModel.Comments)
                {

            <tr>
                <td><img src="~/@item.User.AvatarPath" /></td>
                <td><h4>@item.AuthorName</h4></td>
                <td>
                    <p>@item.Text</p>
                </td>
                <td><span>@item.CommentDate</span></td>
            </tr>
                }
            </table>
            @if (Model.IndexViewModel.PageViewModel.HasPrevPage)
            {
                <button onclick="pagination(@Model.Topic.Id,@(Model.IndexViewModel.PageViewModel.PageNumber - 1))" class="btn btn-dark btn">
                    Назад
                </button>
            }
            @if (Model.IndexViewModel.PageViewModel.HasNextPage)
            {
                <button onclick="pagination(@Model.Topic.Id,@(Model.IndexViewModel.PageViewModel.PageNumber + 1))"
                        class="btn btn-dark btn">
                    Вперед
                </button>
            }
        </div>
        
    </div>
    
}


    <hr>
    <b>Комментировать :</b>

    <div class="col-md-4">
        <form>
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <div class="form-group">
                <label asp-for="@Model.Comment.Text" class="control-label">Сообщение</label>
                <input name="text" class="form-control" />
                <span asp-validation-for="@Model.Comment.Text" class="text-danger"></span>
            </div>
            <div class="form-group">
                <input type="hidden" value="@Model.Topic.Id" name="topicId" />
            </div>
            <div class="form-group">
                <input type="hidden" value="@Model.Topic.UserId" name="userId" />
            </div>
            <div class="form-group">
                <input type="button" onclick="create(this.form, @Model.IndexViewModel.PageViewModel.PageNumber)"value="Ответить" class="btn btn-primary" />
            </div>
        </form>
    </div>
<script>

    function create(form, page) {
        var elems = form.elements;
        $('#comments').load('@Url.Action("CreateComment", "Comment")',
            { text: elems.text.value, topicId: elems.topicId.value, userId: elems.userId.value, pageNumber:page});
        }
    function pagination(topicId, pageNumber) {
        $('#comments').load('@Url.Action("PaginationAjaxResultAsync", "Topic")',
            { id: topicId, pageNumber:pageNumber});
    }
</script>

WebApplication1/Views/Topic/PaginationResult.cshtml
@model WebApplication1.ViewModels.CommentViewModel

<div id="result">
    <table>
        <tr>
            <th></th>
            <th>Автор</th>
            <th>Сообщение</th>
            <th>Дата ответа</th>
        </tr>

        @foreach (var item in Model.IndexViewModel.Comments)
        {

            <tr>
                <td><img src="~/@item.User.AvatarPath"/></td>
                <td><h4>@item.AuthorName</h4></td>
                <td>
                    <p>@item.Text</p>
                </td>
                <td><span>@item.CommentDate</span></td>
            </tr>
        }
    </table>
@if (Model.IndexViewModel.PageViewModel.HasPrevPage)
{
    <button onclick="pagination(@Model.Topic.Id,@(Model.IndexViewModel.PageViewModel.PageNumber - 1))" class="btn btn-dark btn">
        Назад
    </button>
}
@if (Model.IndexViewModel.PageViewModel.HasNextPage)
{
    <button onclick="pagination(@Model.Topic.Id, @(Model.IndexViewModel.PageViewModel.PageNumber + 1))"
            class="btn btn-dark btn">
        Вперед
    </button>
}
</div>